/* xnoise-mpris.c generated by valac, the Vala compiler
 * generated from xnoise-mpris.vala, do not modify */

/* xnoise-mpris.vala
 *
 * Copyright (C) 2010 Andreas Obergrusberger
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The Xnoise authors hereby grant permission for non-GPL compatible
 *  GStreamer plugins to be used and distributed together with GStreamer
 *  and Xnoise. This permission is above and beyond the permissions granted
 *  by the GPL license by which Xnoise is covered. If you modify this code
 *  you may extend this exception to your version of the code, but you are not
 *  obligated to do so. If you do not wish to do so, delete this exception
 *  statement from your version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author:
 * Andreas Obergrusberger
 */
/* exposes xnoise's player and tracklist controls via dbus using the standardized mpris interface*/
/* refer to http://www.mpris.org for interface definition*/

#include <glib.h>
#include <glib-object.h>
#include <xnoise.h>
#include <dbus/dbus-glib-lowlevel.h>
#include <dbus/dbus-glib.h>
#include <stdlib.h>
#include <string.h>
#include <dbus/dbus.h>
#include <stdio.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>


#define XNOISE_TYPE_MPRIS (xnoise_mpris_get_type ())
#define XNOISE_MPRIS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), XNOISE_TYPE_MPRIS, XnoiseMpris))
#define XNOISE_MPRIS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), XNOISE_TYPE_MPRIS, XnoiseMprisClass))
#define XNOISE_IS_MPRIS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XNOISE_TYPE_MPRIS))
#define XNOISE_IS_MPRIS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), XNOISE_TYPE_MPRIS))
#define XNOISE_MPRIS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), XNOISE_TYPE_MPRIS, XnoiseMprisClass))

typedef struct _XnoiseMpris XnoiseMpris;
typedef struct _XnoiseMprisClass XnoiseMprisClass;
typedef struct _XnoiseMprisPrivate XnoiseMprisPrivate;

#define TYPE_MPRIS_PLAYER (mpris_player_get_type ())
#define MPRIS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MPRIS_PLAYER, MprisPlayer))
#define MPRIS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MPRIS_PLAYER, MprisPlayerClass))
#define IS_MPRIS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MPRIS_PLAYER))
#define IS_MPRIS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MPRIS_PLAYER))
#define MPRIS_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MPRIS_PLAYER, MprisPlayerClass))

typedef struct _MprisPlayer MprisPlayer;
typedef struct _MprisPlayerClass MprisPlayerClass;

#define TYPE_MPRIS_ROOT (mpris_root_get_type ())
#define MPRIS_ROOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MPRIS_ROOT, MprisRoot))
#define MPRIS_ROOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MPRIS_ROOT, MprisRootClass))
#define IS_MPRIS_ROOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MPRIS_ROOT))
#define IS_MPRIS_ROOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MPRIS_ROOT))
#define MPRIS_ROOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MPRIS_ROOT, MprisRootClass))

typedef struct _MprisRoot MprisRoot;
typedef struct _MprisRootClass MprisRootClass;

#define TYPE_MPRIS_TRACK_LIST (mpris_track_list_get_type ())
#define MPRIS_TRACK_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MPRIS_TRACK_LIST, MprisTrackList))
#define MPRIS_TRACK_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MPRIS_TRACK_LIST, MprisTrackListClass))
#define IS_MPRIS_TRACK_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MPRIS_TRACK_LIST))
#define IS_MPRIS_TRACK_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MPRIS_TRACK_LIST))
#define MPRIS_TRACK_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MPRIS_TRACK_LIST, MprisTrackListClass))

typedef struct _MprisTrackList MprisTrackList;
typedef struct _MprisTrackListClass MprisTrackListClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _dbus_g_connection_unref0(var) ((var == NULL) ? NULL : (var = (dbus_g_connection_unref (var), NULL)))
typedef struct _DBusObjectVTable _DBusObjectVTable;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _MprisRootPrivate MprisRootPrivate;

#define TYPE_VERSION_STRUCT (version_struct_get_type ())
typedef struct _VersionStruct VersionStruct;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _MprisPlayerPrivate MprisPlayerPrivate;

#define MPRIS_PLAYER_TYPE_DIRECTION (mpris_player_direction_get_type ())

#define TYPE_STATUS_STRUCT (status_struct_get_type ())
typedef struct _StatusStruct StatusStruct;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
typedef struct _MprisTrackListPrivate MprisTrackListPrivate;

struct _XnoiseMpris {
	GObject parent_instance;
	XnoiseMprisPrivate * priv;
	DBusGConnection* conn;
	DBusGProxy* bus;
	MprisPlayer* player;
	MprisRoot* root;
	MprisTrackList* tracklist;
};

struct _XnoiseMprisClass {
	GObjectClass parent_class;
};

struct _XnoiseMprisPrivate {
	XnoiseMain* _xn;
};

struct _DBusObjectVTable {
	void (*register_object) (DBusConnection*, const char*, void*);
};

struct _MprisRoot {
	GObject parent_instance;
	MprisRootPrivate * priv;
};

struct _MprisRootClass {
	GObjectClass parent_class;
};

struct _VersionStruct {
	guint16 Major;
	guint16 Minor;
};

struct _MprisPlayer {
	GObject parent_instance;
	MprisPlayerPrivate * priv;
};

struct _MprisPlayerClass {
	GObjectClass parent_class;
};

struct _MprisPlayerPrivate {
	XnoiseMain* xn;
};

typedef enum  {
	MPRIS_PLAYER_DIRECTION_NEXT = 0,
	MPRIS_PLAYER_DIRECTION_PREVIOUS,
	MPRIS_PLAYER_DIRECTION_STOP
} MprisPlayerDirection;

struct _StatusStruct {
	gint playback_state;
	gint shuffle_state;
	gint repeat_current_state;
	gint endless_state;
};

struct _MprisTrackList {
	GObject parent_instance;
	MprisTrackListPrivate * priv;
};

struct _MprisTrackListClass {
	GObjectClass parent_class;
};


static gpointer xnoise_mpris_parent_class = NULL;
static XnoiseIPluginIface* xnoise_mpris_xnoise_iplugin_parent_iface = NULL;
static GType xnoise_mpris_type_id = 0;
static gpointer mpris_root_parent_class = NULL;
static GType mpris_root_type_id = 0;
static gpointer mpris_player_parent_class = NULL;
static GType mpris_player_type_id = 0;
static gpointer mpris_track_list_parent_class = NULL;
static GType mpris_track_list_type_id = 0;

GType xnoise_mpris_get_type (void);
GType xnoise_mpris_register_type (GTypeModule * module);
GType mpris_player_get_type (void);
GType mpris_player_register_type (GTypeModule * module);
GType mpris_root_get_type (void);
GType mpris_root_register_type (GTypeModule * module);
GType mpris_track_list_get_type (void);
GType mpris_track_list_register_type (GTypeModule * module);
#define XNOISE_MPRIS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), XNOISE_TYPE_MPRIS, XnoiseMprisPrivate))
enum  {
	XNOISE_MPRIS_DUMMY_PROPERTY,
	XNOISE_MPRIS_XN,
	XNOISE_MPRIS_NAME
};
static guint _dynamic_request_name0 (DBusGProxy* self, const char* param1, guint param2, GError** error);
MprisRoot* mpris_root_new (void);
MprisRoot* mpris_root_construct (GType object_type);
static void _vala_dbus_register_object (DBusConnection* connection, const char* path, void* object);
static void _vala_dbus_unregister_object (gpointer connection, GObject* object);
MprisPlayer* mpris_player_new (void);
MprisPlayer* mpris_player_construct (GType object_type);
MprisTrackList* mpris_track_list_new (void);
MprisTrackList* mpris_track_list_construct (GType object_type);
static gboolean xnoise_mpris_real_init (XnoiseIPlugin* base);
static GtkWidget* xnoise_mpris_real_get_settings_widget (XnoiseIPlugin* base);
static GtkWidget* xnoise_mpris_real_get_singleline_settings_widget (XnoiseIPlugin* base);
static gboolean xnoise_mpris_real_has_settings_widget (XnoiseIPlugin* base);
static gboolean xnoise_mpris_real_has_singleline_settings_widget (XnoiseIPlugin* base);
XnoiseMpris* xnoise_mpris_new (void);
XnoiseMpris* xnoise_mpris_construct (GType object_type);
static void xnoise_mpris_finalize (GObject* obj);
static void xnoise_mpris_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void xnoise_mpris_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
enum  {
	MPRIS_ROOT_DUMMY_PROPERTY
};
char* mpris_root_Identity (MprisRoot* self);
void mpris_root_Quit (MprisRoot* self);
GType version_struct_get_type (void);
VersionStruct* version_struct_dup (const VersionStruct* self);
void version_struct_free (VersionStruct* self);
void mpris_root_MprisVersion (MprisRoot* self, VersionStruct* result);
void mpris_root_dbus_register_object (DBusConnection* connection, const char* path, void* object);
void _mpris_root_dbus_unregister (DBusConnection* connection, void* _user_data_);
DBusHandlerResult mpris_root_dbus_message (DBusConnection* connection, DBusMessage* message, void* object);
static DBusHandlerResult _dbus_mpris_root_introspect (MprisRoot* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_mpris_root_property_get_all (MprisRoot* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_mpris_root_Identity (MprisRoot* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_mpris_root_Quit (MprisRoot* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_mpris_root_MprisVersion (MprisRoot* self, DBusConnection* connection, DBusMessage* message);
#define MPRIS_PLAYER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MPRIS_PLAYER, MprisPlayerPrivate))
enum  {
	MPRIS_PLAYER_DUMMY_PROPERTY
};
static GType mpris_player_direction_get_type (void) G_GNUC_UNUSED;
void mpris_player_Next (MprisPlayer* self);
void mpris_player_Prev (MprisPlayer* self);
void mpris_player_Pause (MprisPlayer* self);
void mpris_player_Stop (MprisPlayer* self);
void mpris_player_Play (MprisPlayer* self);
void mpris_player_Repeat (MprisPlayer* self, gboolean State);
GType status_struct_get_type (void);
StatusStruct* status_struct_dup (const StatusStruct* self);
void status_struct_free (StatusStruct* self);
void mpris_player_GetStatus (MprisPlayer* self, StatusStruct* result);
GHashTable* mpris_player_GetMetadata (MprisPlayer* self);
gint mpris_player_GetCaps (MprisPlayer* self);
void mpris_player_VolumeSet (MprisPlayer* self, gint Volume);
gint mpris_player_VolumeGet (MprisPlayer* self);
void mpris_player_PositionSet (MprisPlayer* self, gint Position);
gint mpris_player_PositionGet (MprisPlayer* self);
void mpris_player_dbus_register_object (DBusConnection* connection, const char* path, void* object);
void _mpris_player_dbus_unregister (DBusConnection* connection, void* _user_data_);
DBusHandlerResult mpris_player_dbus_message (DBusConnection* connection, DBusMessage* message, void* object);
static DBusHandlerResult _dbus_mpris_player_introspect (MprisPlayer* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_mpris_player_property_get_all (MprisPlayer* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_mpris_player_Next (MprisPlayer* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_mpris_player_Prev (MprisPlayer* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_mpris_player_Pause (MprisPlayer* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_mpris_player_Stop (MprisPlayer* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_mpris_player_Play (MprisPlayer* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_mpris_player_Repeat (MprisPlayer* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_mpris_player_GetStatus (MprisPlayer* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_mpris_player_GetMetadata (MprisPlayer* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_mpris_player_GetCaps (MprisPlayer* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_mpris_player_VolumeSet (MprisPlayer* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_mpris_player_VolumeGet (MprisPlayer* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_mpris_player_PositionSet (MprisPlayer* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_mpris_player_PositionGet (MprisPlayer* self, DBusConnection* connection, DBusMessage* message);
static void _dbus_mpris_player_track_change (GObject* _sender, GHashTable* Metadata, DBusConnection* _connection);
static void _dbus_mpris_player_status_change (GObject* _sender, StatusStruct* Status, DBusConnection* _connection);
static void _dbus_mpris_player_caps_change (GObject* _sender, gint Capabilities, DBusConnection* _connection);
static void mpris_player_finalize (GObject* obj);
enum  {
	MPRIS_TRACK_LIST_DUMMY_PROPERTY
};
GHashTable* mpris_track_list_GetMetadata (MprisTrackList* self, gint Position);
gint mpris_track_list_GetCurrentTrack (MprisTrackList* self);
gint mpris_track_list_GetLength (MprisTrackList* self);
gint mpris_track_list_AddTrack (MprisTrackList* self, const char* Uri, gboolean PlayImmediately);
void mpris_track_list_DelTrack (MprisTrackList* self, gint Position);
void mpris_track_list_SetLoop (MprisTrackList* self, gboolean State);
void mpris_track_list_SetRandom (MprisTrackList* self, gboolean State);
void mpris_track_list_dbus_register_object (DBusConnection* connection, const char* path, void* object);
void _mpris_track_list_dbus_unregister (DBusConnection* connection, void* _user_data_);
DBusHandlerResult mpris_track_list_dbus_message (DBusConnection* connection, DBusMessage* message, void* object);
static DBusHandlerResult _dbus_mpris_track_list_introspect (MprisTrackList* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_mpris_track_list_property_get_all (MprisTrackList* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_mpris_track_list_GetMetadata (MprisTrackList* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_mpris_track_list_GetCurrentTrack (MprisTrackList* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_mpris_track_list_GetLength (MprisTrackList* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_mpris_track_list_AddTrack (MprisTrackList* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_mpris_track_list_DelTrack (MprisTrackList* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_mpris_track_list_SetLoop (MprisTrackList* self, DBusConnection* connection, DBusMessage* message);
static DBusHandlerResult _dbus_mpris_track_list_SetRandom (MprisTrackList* self, DBusConnection* connection, DBusMessage* message);
static void _dbus_mpris_track_list_track_list_change (GObject* _sender, gint Nb_Tracks, DBusConnection* _connection);
static int _vala_strcmp0 (const char * str1, const char * str2);

static const DBusObjectPathVTable _mpris_root_dbus_path_vtable = {_mpris_root_dbus_unregister, mpris_root_dbus_message};
static const _DBusObjectVTable _mpris_root_dbus_vtable = {mpris_root_dbus_register_object};
static const DBusObjectPathVTable _mpris_player_dbus_path_vtable = {_mpris_player_dbus_unregister, mpris_player_dbus_message};
static const _DBusObjectVTable _mpris_player_dbus_vtable = {mpris_player_dbus_register_object};
static const DBusObjectPathVTable _mpris_track_list_dbus_path_vtable = {_mpris_track_list_dbus_unregister, mpris_track_list_dbus_message};
static const _DBusObjectVTable _mpris_track_list_dbus_vtable = {mpris_track_list_dbus_register_object};

static void g_cclosure_user_marshal_VOID__BOXED (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);

static guint _dynamic_request_name0 (DBusGProxy* self, const char* param1, guint param2, GError** error) {
	guint result;
	dbus_g_proxy_call (self, "RequestName", error, G_TYPE_STRING, param1, G_TYPE_UINT, param2, G_TYPE_INVALID, G_TYPE_UINT, &result, G_TYPE_INVALID);
	if (*error) {
		return 0U;
	}
	return result;
}


static void _vala_dbus_register_object (DBusConnection* connection, const char* path, void* object) {
	const _DBusObjectVTable * vtable;
	vtable = g_type_get_qdata (G_TYPE_FROM_INSTANCE (object), g_quark_from_static_string ("DBusObjectVTable"));
	if (vtable) {
		vtable->register_object (connection, path, object);
	} else {
		g_warning ("Object does not implement any D-Bus interface");
	}
}


static void _vala_dbus_unregister_object (gpointer connection, GObject* object) {
	char* path;
	path = g_object_steal_data ((GObject*) object, "dbus_object_path");
	dbus_connection_unregister_object_path (connection, path);
	g_free (path);
}


static gboolean xnoise_mpris_real_init (XnoiseIPlugin* base) {
	XnoiseMpris * self;
	gboolean result = FALSE;
	GError * _inner_error_;
	self = (XnoiseMpris*) base;
	_inner_error_ = NULL;
	{
		DBusGConnection* _tmp0_;
		DBusGConnection* _tmp1_;
		DBusGProxy* _tmp2_;
		guint request_name_result;
		_tmp0_ = dbus_g_bus_get (DBUS_BUS_SESSION, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch0_g_error;
		}
		self->conn = (_tmp1_ = _tmp0_, _dbus_g_connection_unref0 (self->conn), _tmp1_);
		if (self->conn == NULL) {
			result = FALSE;
			return result;
		}
		self->bus = (_tmp2_ = dbus_g_proxy_new_for_name (self->conn, "org.freedesktop.DBus", "/org/freedesktop/DBus", "org.freedesktop.DBus"), _g_object_unref0 (self->bus), _tmp2_);
		if (self->bus == NULL) {
			result = FALSE;
			return result;
		}
		request_name_result = _dynamic_request_name0 (self->bus, "org.mpris.xnoise", (guint) 0, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch0_g_error;
		}
		if (request_name_result == DBUS_REQUEST_NAME_REPLY_PRIMARY_OWNER) {
			MprisRoot* _tmp3_;
			MprisPlayer* _tmp4_;
			MprisTrackList* _tmp5_;
			self->root = (_tmp3_ = mpris_root_new (), _g_object_unref0 (self->root), _tmp3_);
			_vala_dbus_register_object (dbus_g_connection_get_connection (self->conn), "/", (GObject*) self->root);
			self->player = (_tmp4_ = mpris_player_new (), _g_object_unref0 (self->player), _tmp4_);
			_vala_dbus_register_object (dbus_g_connection_get_connection (self->conn), "/Player", (GObject*) self->player);
			self->tracklist = (_tmp5_ = mpris_track_list_new (), _g_object_unref0 (self->tracklist), _tmp5_);
			_vala_dbus_register_object (dbus_g_connection_get_connection (self->conn), "/TrackList", (GObject*) self->tracklist);
		} else {
			fprintf (stderr, "mpris: cannot acquire name org.mpris.xnoise in session bus");
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			fprintf (stderr, "mpris: failed to setup dbus interface: %s\n", e->message);
			result = FALSE;
			_g_error_free0 (e);
			return result;
		}
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	result = TRUE;
	return result;
}


static GtkWidget* xnoise_mpris_real_get_settings_widget (XnoiseIPlugin* base) {
	XnoiseMpris * self;
	GtkWidget* result = NULL;
	self = (XnoiseMpris*) base;
	result = NULL;
	return result;
}


static GtkWidget* xnoise_mpris_real_get_singleline_settings_widget (XnoiseIPlugin* base) {
	XnoiseMpris * self;
	GtkWidget* result = NULL;
	self = (XnoiseMpris*) base;
	result = NULL;
	return result;
}


static gboolean xnoise_mpris_real_has_settings_widget (XnoiseIPlugin* base) {
	XnoiseMpris * self;
	gboolean result = FALSE;
	self = (XnoiseMpris*) base;
	result = FALSE;
	return result;
}


static gboolean xnoise_mpris_real_has_singleline_settings_widget (XnoiseIPlugin* base) {
	XnoiseMpris * self;
	gboolean result = FALSE;
	self = (XnoiseMpris*) base;
	result = FALSE;
	return result;
}


XnoiseMpris* xnoise_mpris_construct (GType object_type) {
	XnoiseMpris * self;
	self = (XnoiseMpris*) g_object_new (object_type, NULL);
	return self;
}


XnoiseMpris* xnoise_mpris_new (void) {
	return xnoise_mpris_construct (XNOISE_TYPE_MPRIS);
}


static XnoiseMain* xnoise_mpris_real_get_xn (XnoiseIPlugin* base) {
	XnoiseMain* result;
	XnoiseMpris* self;
	self = (XnoiseMpris*) base;
	result = self->priv->_xn;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void xnoise_mpris_real_set_xn (XnoiseIPlugin* base, XnoiseMain* value) {
	XnoiseMpris* self;
	XnoiseMain* _tmp0_;
	self = (XnoiseMpris*) base;
	self->priv->_xn = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_xn), _tmp0_);
	g_object_notify ((GObject *) self, "xn");
}


static const char* xnoise_mpris_real_get_name (XnoiseIPlugin* base) {
	const char* result;
	XnoiseMpris* self;
	self = (XnoiseMpris*) base;
	result = "mpris";
	return result;
}


static void xnoise_mpris_class_init (XnoiseMprisClass * klass) {
	xnoise_mpris_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (XnoiseMprisPrivate));
	G_OBJECT_CLASS (klass)->get_property = xnoise_mpris_get_property;
	G_OBJECT_CLASS (klass)->set_property = xnoise_mpris_set_property;
	G_OBJECT_CLASS (klass)->finalize = xnoise_mpris_finalize;
	g_object_class_override_property (G_OBJECT_CLASS (klass), XNOISE_MPRIS_XN, "xn");
	g_object_class_override_property (G_OBJECT_CLASS (klass), XNOISE_MPRIS_NAME, "name");
}


static void xnoise_mpris_xnoise_iplugin_interface_init (XnoiseIPluginIface * iface) {
	xnoise_mpris_xnoise_iplugin_parent_iface = g_type_interface_peek_parent (iface);
	iface->init = xnoise_mpris_real_init;
	iface->get_settings_widget = xnoise_mpris_real_get_settings_widget;
	iface->get_singleline_settings_widget = xnoise_mpris_real_get_singleline_settings_widget;
	iface->has_settings_widget = xnoise_mpris_real_has_settings_widget;
	iface->has_singleline_settings_widget = xnoise_mpris_real_has_singleline_settings_widget;
	iface->get_xn = xnoise_mpris_real_get_xn;
	iface->set_xn = xnoise_mpris_real_set_xn;
	iface->get_name = xnoise_mpris_real_get_name;
}


static void xnoise_mpris_instance_init (XnoiseMpris * self) {
	self->priv = XNOISE_MPRIS_GET_PRIVATE (self);
	self->player = NULL;
	self->root = NULL;
	self->tracklist = NULL;
}


static void xnoise_mpris_finalize (GObject* obj) {
	XnoiseMpris * self;
	self = XNOISE_MPRIS (obj);
	{
	}
	_g_object_unref0 (self->priv->_xn);
	_dbus_g_connection_unref0 (self->conn);
	_g_object_unref0 (self->bus);
	_g_object_unref0 (self->player);
	_g_object_unref0 (self->root);
	_g_object_unref0 (self->tracklist);
	G_OBJECT_CLASS (xnoise_mpris_parent_class)->finalize (obj);
}


GType xnoise_mpris_get_type (void) {
	return xnoise_mpris_type_id;
}


GType xnoise_mpris_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (XnoiseMprisClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xnoise_mpris_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XnoiseMpris), 0, (GInstanceInitFunc) xnoise_mpris_instance_init, NULL };
	static const GInterfaceInfo xnoise_iplugin_info = { (GInterfaceInitFunc) xnoise_mpris_xnoise_iplugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	xnoise_mpris_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "XnoiseMpris", &g_define_type_info, 0);
	g_type_module_add_interface (module, xnoise_mpris_type_id, XNOISE_TYPE_IPLUGIN, &xnoise_iplugin_info);
	return xnoise_mpris_type_id;
}


static void xnoise_mpris_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	XnoiseMpris * self;
	self = XNOISE_MPRIS (object);
	switch (property_id) {
		case XNOISE_MPRIS_XN:
		g_value_set_object (value, xnoise_iplugin_get_xn ((XnoiseIPlugin*) self));
		break;
		case XNOISE_MPRIS_NAME:
		g_value_set_string (value, xnoise_iplugin_get_name ((XnoiseIPlugin*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void xnoise_mpris_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	XnoiseMpris * self;
	self = XNOISE_MPRIS (object);
	switch (property_id) {
		case XNOISE_MPRIS_XN:
		xnoise_iplugin_set_xn ((XnoiseIPlugin*) self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


char* mpris_root_Identity (MprisRoot* self) {
	char* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = g_strdup ("xnoise");
	return result;
}


void mpris_root_Quit (MprisRoot* self) {
	g_return_if_fail (self != NULL);
}


void mpris_root_MprisVersion (MprisRoot* self, VersionStruct* result) {
	VersionStruct v = {0};
	g_return_if_fail (self != NULL);
	memset (&v, 0, sizeof (VersionStruct));
	v.Major = (guint16) 1;
	v.Minor = (guint16) 0;
	*result = v;
	return;
}


MprisRoot* mpris_root_construct (GType object_type) {
	MprisRoot * self;
	self = (MprisRoot*) g_object_new (object_type, NULL);
	return self;
}


MprisRoot* mpris_root_new (void) {
	return mpris_root_construct (TYPE_MPRIS_ROOT);
}


void _mpris_root_dbus_unregister (DBusConnection* connection, void* _user_data_) {
}


static DBusHandlerResult _dbus_mpris_root_introspect (MprisRoot* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessage* reply;
	DBusMessageIter iter;
	GString* xml_data;
	char** children;
	int i;
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	xml_data = g_string_new ("<!DOCTYPE node PUBLIC \"-//freedesktop//DTD D-BUS Object Introspection 1.0//EN\" \"http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd\">\n");
	g_string_append (xml_data, "<node>\n<interface name=\"org.freedesktop.DBus.Introspectable\">\n  <method name=\"Introspect\">\n    <arg name=\"data\" direction=\"out\" type=\"s\"/>\n  </method>\n</interface>\n<interface name=\"org.freedesktop.DBus.Properties\">\n  <method name=\"Get\">\n    <arg name=\"interface\" direction=\"in\" type=\"s\"/>\n    <arg name=\"propname\" direction=\"in\" type=\"s\"/>\n    <arg name=\"value\" direction=\"out\" type=\"v\"/>\n  </method>\n  <method name=\"Set\">\n    <arg name=\"interface\" direction=\"in\" type=\"s\"/>\n    <arg name=\"propname\" direction=\"in\" type=\"s\"/>\n    <arg name=\"value\" direction=\"in\" type=\"v\"/>\n  </method>\n  <method name=\"GetAll\">\n    <arg name=\"interface\" direction=\"in\" type=\"s\"/>\n    <arg name=\"props\" direction=\"out\" type=\"a{sv}\"/>\n  </method>\n</interface>\n<interface name=\"org.freedesktop.MediaPlayer\">\n  <method name=\"Identity\">\n    <arg name=\"result\" type=\"s\" direction=\"out\"/>\n  </method>\n  <method name=\"Quit\">\n  </method>\n  <method name=\"MprisVersion\">\n    <arg name=\"result\" type=\"(qq)\" direction=\"out\"/>\n  </method>\n</interface>\n");
	dbus_connection_list_registered (connection, g_object_get_data ((GObject *) self, "dbus_object_path"), &children);
	for (i = 0; children[i]; i++) {
		g_string_append_printf (xml_data, "<node name=\"%s\"/>\n", children[i]);
	}
	dbus_free_string_array (children);
	g_string_append (xml_data, "</node>\n");
	dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &xml_data->str);
	g_string_free (xml_data, TRUE);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_mpris_root_property_get_all (MprisRoot* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessage* reply;
	DBusMessageIter iter, reply_iter, subiter;
	char* interface_name;
	const char* _tmp0_;
	if (strcmp (dbus_message_get_signature (message), "s")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &reply_iter);
	dbus_message_iter_get_basic (&iter, &_tmp0_);
	dbus_message_iter_next (&iter);
	interface_name = g_strdup (_tmp0_);
	if (strcmp (interface_name, "org.freedesktop.MediaPlayer") == 0) {
		dbus_message_iter_open_container (&reply_iter, DBUS_TYPE_ARRAY, "{sv}", &subiter);
		dbus_message_iter_close_container (&reply_iter, &subiter);
	} else {
		dbus_message_unref (reply);
		reply = NULL;
	}
	g_free (interface_name);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_mpris_root_Identity (MprisRoot* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	char* result;
	DBusMessage* reply;
	const char* _tmp1_;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	result = mpris_root_Identity (self);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_tmp1_ = result;
	dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &_tmp1_);
	_g_free0 (result);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_mpris_root_Quit (MprisRoot* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	DBusMessage* reply;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	mpris_root_Quit (self);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_mpris_root_MprisVersion (MprisRoot* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	VersionStruct result = {0};
	DBusMessage* reply;
	DBusMessageIter _tmp2_;
	dbus_uint16_t _tmp3_;
	dbus_uint16_t _tmp4_;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	mpris_root_MprisVersion (self, &result);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	dbus_message_iter_open_container (&iter, DBUS_TYPE_STRUCT, NULL, &_tmp2_);
	_tmp3_ = result.Major;
	dbus_message_iter_append_basic (&_tmp2_, DBUS_TYPE_UINT16, &_tmp3_);
	_tmp4_ = result.Minor;
	dbus_message_iter_append_basic (&_tmp2_, DBUS_TYPE_UINT16, &_tmp4_);
	dbus_message_iter_close_container (&iter, &_tmp2_);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


DBusHandlerResult mpris_root_dbus_message (DBusConnection* connection, DBusMessage* message, void* object) {
	DBusHandlerResult result;
	result = DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	if (dbus_message_is_method_call (message, "org.freedesktop.DBus.Introspectable", "Introspect")) {
		result = _dbus_mpris_root_introspect (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.DBus.Properties", "GetAll")) {
		result = _dbus_mpris_root_property_get_all (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.MediaPlayer", "Identity")) {
		result = _dbus_mpris_root_Identity (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.MediaPlayer", "Quit")) {
		result = _dbus_mpris_root_Quit (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.MediaPlayer", "MprisVersion")) {
		result = _dbus_mpris_root_MprisVersion (object, connection, message);
	}
	if (result == DBUS_HANDLER_RESULT_HANDLED) {
		return result;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


void mpris_root_dbus_register_object (DBusConnection* connection, const char* path, void* object) {
	if (!g_object_get_data (object, "dbus_object_path")) {
		g_object_set_data (object, "dbus_object_path", g_strdup (path));
		dbus_connection_register_object_path (connection, path, &_mpris_root_dbus_path_vtable, object);
		g_object_weak_ref (object, _vala_dbus_unregister_object, connection);
	}
}


static void mpris_root_class_init (MprisRootClass * klass) {
	mpris_root_parent_class = g_type_class_peek_parent (klass);
	g_type_set_qdata (TYPE_MPRIS_ROOT, g_quark_from_static_string ("DBusObjectVTable"), (void*) (&_mpris_root_dbus_vtable));
}


static void mpris_root_instance_init (MprisRoot * self) {
}


GType mpris_root_get_type (void) {
	return mpris_root_type_id;
}


GType mpris_root_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (MprisRootClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mpris_root_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MprisRoot), 0, (GInstanceInitFunc) mpris_root_instance_init, NULL };
	mpris_root_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "MprisRoot", &g_define_type_info, 0);
	return mpris_root_type_id;
}


VersionStruct* version_struct_dup (const VersionStruct* self) {
	VersionStruct* dup;
	dup = g_new0 (VersionStruct, 1);
	memcpy (dup, self, sizeof (VersionStruct));
	return dup;
}


void version_struct_free (VersionStruct* self) {
	g_free (self);
}


GType version_struct_get_type (void) {
	static volatile gsize version_struct_type_id__volatile = 0;
	if (g_once_init_enter (&version_struct_type_id__volatile)) {
		GType version_struct_type_id;
		version_struct_type_id = g_boxed_type_register_static ("VersionStruct", (GBoxedCopyFunc) version_struct_dup, (GBoxedFreeFunc) version_struct_free);
		g_once_init_leave (&version_struct_type_id__volatile, version_struct_type_id);
	}
	return version_struct_type_id__volatile;
}


static GType mpris_player_direction_get_type (void) {
	static volatile gsize mpris_player_direction_type_id__volatile = 0;
	if (g_once_init_enter (&mpris_player_direction_type_id__volatile)) {
		static const GEnumValue values[] = {{MPRIS_PLAYER_DIRECTION_NEXT, "MPRIS_PLAYER_DIRECTION_NEXT", "next"}, {MPRIS_PLAYER_DIRECTION_PREVIOUS, "MPRIS_PLAYER_DIRECTION_PREVIOUS", "previous"}, {MPRIS_PLAYER_DIRECTION_STOP, "MPRIS_PLAYER_DIRECTION_STOP", "stop"}, {0, NULL, NULL}};
		GType mpris_player_direction_type_id;
		mpris_player_direction_type_id = g_enum_register_static ("MprisPlayerDirection", values);
		g_once_init_leave (&mpris_player_direction_type_id__volatile, mpris_player_direction_type_id);
	}
	return mpris_player_direction_type_id__volatile;
}


MprisPlayer* mpris_player_construct (GType object_type) {
	MprisPlayer * self;
	self = (MprisPlayer*) g_object_new (object_type, NULL);
	self->priv->xn = xnoise_main_get_instance ();
	return self;
}


MprisPlayer* mpris_player_new (void) {
	return mpris_player_construct (TYPE_MPRIS_PLAYER);
}


void mpris_player_Next (MprisPlayer* self) {
	g_return_if_fail (self != NULL);
	g_print ("next\n");
	xnoise_main_window_change_track (self->priv->xn->main_window, XNOISE_CONTROL_BUTTON_DIRECTION_NEXT, FALSE);
}


void mpris_player_Prev (MprisPlayer* self) {
	g_return_if_fail (self != NULL);
	g_print ("prev\n");
	xnoise_main_window_change_track (self->priv->xn->main_window, XNOISE_CONTROL_BUTTON_DIRECTION_PREVIOUS, FALSE);
}


void mpris_player_Pause (MprisPlayer* self) {
	g_return_if_fail (self != NULL);
	if (xnoise_global_access_get_current_uri (xnoise_global) == NULL) {
		char* uri;
		gboolean _tmp0_ = FALSE;
		uri = xnoise_track_list_model_get_uri_for_current_position (self->priv->xn->tl->tracklistmodel);
		if (_vala_strcmp0 (uri, "") != 0) {
			_tmp0_ = uri != NULL;
		} else {
			_tmp0_ = FALSE;
		}
		if (_tmp0_) {
			xnoise_global_access_set_current_uri (xnoise_global, uri);
		}
		_g_free0 (uri);
	}
	xnoise_global_access_set_track_state (xnoise_global, XNOISE_GLOBAL_ACCESS_TRACK_STATE_PAUSED);
}


void mpris_player_Stop (MprisPlayer* self) {
	g_return_if_fail (self != NULL);
	xnoise_main_window_stop (self->priv->xn->main_window);
}


void mpris_player_Play (MprisPlayer* self) {
	g_return_if_fail (self != NULL);
	if (xnoise_global_access_get_current_uri (xnoise_global) == NULL) {
		char* uri;
		gboolean _tmp0_ = FALSE;
		uri = xnoise_track_list_model_get_uri_for_current_position (self->priv->xn->tl->tracklistmodel);
		if (_vala_strcmp0 (uri, "") != 0) {
			_tmp0_ = uri != NULL;
		} else {
			_tmp0_ = FALSE;
		}
		if (_tmp0_) {
			xnoise_global_access_set_current_uri (xnoise_global, uri);
		}
		_g_free0 (uri);
	}
	if (!(xnoise_global_access_get_track_state (xnoise_global) == XNOISE_GLOBAL_ACCESS_TRACK_STATE_PLAYING)) {
		xnoise_global_access_set_track_state (xnoise_global, XNOISE_GLOBAL_ACCESS_TRACK_STATE_PLAYING);
	}
}


void mpris_player_Repeat (MprisPlayer* self, gboolean State) {
	g_return_if_fail (self != NULL);
}


void mpris_player_GetStatus (MprisPlayer* self, StatusStruct* result) {
	StatusStruct ss = {0};
	g_return_if_fail (self != NULL);
	memset (&ss, 0, sizeof (StatusStruct));
	*result = ss;
	return;
}


GHashTable* mpris_player_GetMetadata (MprisPlayer* self) {
	GHashTable* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = NULL;
	return result;
}


gint mpris_player_GetCaps (MprisPlayer* self) {
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	result = 0;
	return result;
}


void mpris_player_VolumeSet (MprisPlayer* self, gint Volume) {
	g_return_if_fail (self != NULL);
	xnoise_gst_player_set_volume (self->priv->xn->gPl, ((double) Volume) / 100);
}


static char* double_to_string (double self) {
	char* result = NULL;
	gint _tmp0__length1;
	gchar* _tmp0_;
	char* _tmp1_;
	result = (_tmp1_ = g_strdup (g_ascii_dtostr ((_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE), _tmp0__length1 = G_ASCII_DTOSTR_BUF_SIZE, _tmp0_), G_ASCII_DTOSTR_BUF_SIZE, self)), _tmp0_ = (g_free (_tmp0_), NULL), _tmp1_);
	return result;
}


gint mpris_player_VolumeGet (MprisPlayer* self) {
	gint result = 0;
	double vol;
	char* vols;
	g_return_val_if_fail (self != NULL, 0);
	vol = 100 * xnoise_gst_player_get_volume (self->priv->xn->gPl);
	vols = double_to_string (vol);
	result = atoi (vols);
	_g_free0 (vols);
	return result;
}


void mpris_player_PositionSet (MprisPlayer* self, gint Position) {
	g_return_if_fail (self != NULL);
	if (xnoise_gst_player_get_length_time (self->priv->xn->gPl) == 0) {
		return;
	}
	xnoise_gst_player_set_gst_position (self->priv->xn->gPl, ((double) Position) / ((double) (xnoise_gst_player_get_length_time (self->priv->xn->gPl) / 1000000)));
}


gint mpris_player_PositionGet (MprisPlayer* self) {
	gint result = 0;
	double pos;
	double rel_pos;
	char* buf;
	g_return_val_if_fail (self != NULL, 0);
	if (xnoise_gst_player_get_length_time (self->priv->xn->gPl) == 0) {
		result = -1;
		return result;
	}
	pos = xnoise_gst_player_get_gst_position (self->priv->xn->gPl);
	rel_pos = (pos * xnoise_gst_player_get_length_time (self->priv->xn->gPl)) / 1000000;
	buf = double_to_string (rel_pos);
	result = atoi (buf);
	_g_free0 (buf);
	return result;
}


void _mpris_player_dbus_unregister (DBusConnection* connection, void* _user_data_) {
}


static DBusHandlerResult _dbus_mpris_player_introspect (MprisPlayer* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessage* reply;
	DBusMessageIter iter;
	GString* xml_data;
	char** children;
	int i;
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	xml_data = g_string_new ("<!DOCTYPE node PUBLIC \"-//freedesktop//DTD D-BUS Object Introspection 1.0//EN\" \"http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd\">\n");
	g_string_append (xml_data, "<node>\n<interface name=\"org.freedesktop.DBus.Introspectable\">\n  <method name=\"Introspect\">\n    <arg name=\"data\" direction=\"out\" type=\"s\"/>\n  </method>\n</interface>\n<interface name=\"org.freedesktop.DBus.Properties\">\n  <method name=\"Get\">\n    <arg name=\"interface\" direction=\"in\" type=\"s\"/>\n    <arg name=\"propname\" direction=\"in\" type=\"s\"/>\n    <arg name=\"value\" direction=\"out\" type=\"v\"/>\n  </method>\n  <method name=\"Set\">\n    <arg name=\"interface\" direction=\"in\" type=\"s\"/>\n    <arg name=\"propname\" direction=\"in\" type=\"s\"/>\n    <arg name=\"value\" direction=\"in\" type=\"v\"/>\n  </method>\n  <method name=\"GetAll\">\n    <arg name=\"interface\" direction=\"in\" type=\"s\"/>\n    <arg name=\"props\" direction=\"out\" type=\"a{sv}\"/>\n  </method>\n</interface>\n<interface name=\"org.freedesktop.MediaPlayer\">\n  <method name=\"Next\">\n  </method>\n  <method name=\"Prev\">\n  </method>\n  <method name=\"Pause\">\n  </method>\n  <method name=\"Stop\">\n  </method>\n  <method name=\"Play\">\n  </method>\n  <method name=\"Repeat\">\n    <arg name=\"State\" type=\"b\" direction=\"in\"/>\n  </method>\n  <method name=\"GetStatus\">\n    <arg name=\"result\" type=\"(iiii)\" direction=\"out\"/>\n  </method>\n  <method name=\"GetMetadata\">\n    <arg name=\"result\" type=\"a{sv}\" direction=\"out\"/>\n  </method>\n  <method name=\"GetCaps\">\n    <arg name=\"result\" type=\"i\" direction=\"out\"/>\n  </method>\n  <method name=\"VolumeSet\">\n    <arg name=\"Volume\" type=\"i\" direction=\"in\"/>\n  </method>\n  <method name=\"VolumeGet\">\n    <arg name=\"result\" type=\"i\" direction=\"out\"/>\n  </method>\n  <method name=\"PositionSet\">\n    <arg name=\"Position\" type=\"i\" direction=\"in\"/>\n  </method>\n  <method name=\"PositionGet\">\n    <arg name=\"result\" type=\"i\" direction=\"out\"/>\n  </method>\n  <signal name=\"TrackChange\">\n    <arg name=\"Metadata\" type=\"a{sv}\"/>\n  </signal>\n  <signal name=\"StatusChange\">\n    <arg name=\"Status\" type=\"(iiii)\"/>\n  </signal>\n  <signal name=\"CapsChange\">\n    <arg name=\"Capabilities\" type=\"i\"/>\n  </signal>\n</interface>\n");
	dbus_connection_list_registered (connection, g_object_get_data ((GObject *) self, "dbus_object_path"), &children);
	for (i = 0; children[i]; i++) {
		g_string_append_printf (xml_data, "<node name=\"%s\"/>\n", children[i]);
	}
	dbus_free_string_array (children);
	g_string_append (xml_data, "</node>\n");
	dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &xml_data->str);
	g_string_free (xml_data, TRUE);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_mpris_player_property_get_all (MprisPlayer* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessage* reply;
	DBusMessageIter iter, reply_iter, subiter;
	char* interface_name;
	const char* _tmp5_;
	if (strcmp (dbus_message_get_signature (message), "s")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &reply_iter);
	dbus_message_iter_get_basic (&iter, &_tmp5_);
	dbus_message_iter_next (&iter);
	interface_name = g_strdup (_tmp5_);
	if (strcmp (interface_name, "org.freedesktop.MediaPlayer") == 0) {
		dbus_message_iter_open_container (&reply_iter, DBUS_TYPE_ARRAY, "{sv}", &subiter);
		dbus_message_iter_close_container (&reply_iter, &subiter);
	} else {
		dbus_message_unref (reply);
		reply = NULL;
	}
	g_free (interface_name);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_mpris_player_Next (MprisPlayer* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	DBusMessage* reply;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	mpris_player_Next (self);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_mpris_player_Prev (MprisPlayer* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	DBusMessage* reply;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	mpris_player_Prev (self);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_mpris_player_Pause (MprisPlayer* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	DBusMessage* reply;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	mpris_player_Pause (self);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_mpris_player_Stop (MprisPlayer* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	DBusMessage* reply;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	mpris_player_Stop (self);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_mpris_player_Play (MprisPlayer* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	DBusMessage* reply;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	mpris_player_Play (self);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_mpris_player_Repeat (MprisPlayer* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	gboolean State = FALSE;
	dbus_bool_t _tmp6_;
	DBusMessage* reply;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "b")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	dbus_message_iter_get_basic (&iter, &_tmp6_);
	dbus_message_iter_next (&iter);
	State = _tmp6_;
	mpris_player_Repeat (self, State);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_mpris_player_GetStatus (MprisPlayer* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	StatusStruct result = {0};
	DBusMessage* reply;
	DBusMessageIter _tmp7_;
	dbus_int32_t _tmp8_;
	dbus_int32_t _tmp9_;
	dbus_int32_t _tmp10_;
	dbus_int32_t _tmp11_;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	mpris_player_GetStatus (self, &result);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	dbus_message_iter_open_container (&iter, DBUS_TYPE_STRUCT, NULL, &_tmp7_);
	_tmp8_ = result.playback_state;
	dbus_message_iter_append_basic (&_tmp7_, DBUS_TYPE_INT32, &_tmp8_);
	_tmp9_ = result.shuffle_state;
	dbus_message_iter_append_basic (&_tmp7_, DBUS_TYPE_INT32, &_tmp9_);
	_tmp10_ = result.repeat_current_state;
	dbus_message_iter_append_basic (&_tmp7_, DBUS_TYPE_INT32, &_tmp10_);
	_tmp11_ = result.endless_state;
	dbus_message_iter_append_basic (&_tmp7_, DBUS_TYPE_INT32, &_tmp11_);
	dbus_message_iter_close_container (&iter, &_tmp7_);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_mpris_player_GetMetadata (MprisPlayer* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	GHashTable* result;
	DBusMessage* reply;
	DBusMessageIter _tmp12_, _tmp13_;
	GHashTableIter _tmp14_;
	gpointer _tmp15_, _tmp16_;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	result = mpris_player_GetMetadata (self);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	dbus_message_iter_open_container (&iter, DBUS_TYPE_ARRAY, "{sv}", &_tmp12_);
	g_hash_table_iter_init (&_tmp14_, result);
	while (g_hash_table_iter_next (&_tmp14_, &_tmp15_, &_tmp16_)) {
		char* _key;
		GValue* _value;
		const char* _tmp17_;
		DBusMessageIter _tmp18_;
		dbus_message_iter_open_container (&_tmp12_, DBUS_TYPE_DICT_ENTRY, NULL, &_tmp13_);
		_key = (char*) _tmp15_;
		_value = (GValue*) _tmp16_;
		_tmp17_ = _key;
		dbus_message_iter_append_basic (&_tmp13_, DBUS_TYPE_STRING, &_tmp17_);
		if (G_VALUE_TYPE (_value) == G_TYPE_UCHAR) {
			guint8 _tmp19_;
			dbus_message_iter_open_container (&_tmp13_, DBUS_TYPE_VARIANT, "y", &_tmp18_);
			_tmp19_ = g_value_get_uchar (_value);
			dbus_message_iter_append_basic (&_tmp18_, DBUS_TYPE_BYTE, &_tmp19_);
			dbus_message_iter_close_container (&_tmp13_, &_tmp18_);
		} else if (G_VALUE_TYPE (_value) == G_TYPE_BOOLEAN) {
			dbus_bool_t _tmp20_;
			dbus_message_iter_open_container (&_tmp13_, DBUS_TYPE_VARIANT, "b", &_tmp18_);
			_tmp20_ = g_value_get_boolean (_value);
			dbus_message_iter_append_basic (&_tmp18_, DBUS_TYPE_BOOLEAN, &_tmp20_);
			dbus_message_iter_close_container (&_tmp13_, &_tmp18_);
		} else if (G_VALUE_TYPE (_value) == G_TYPE_INT) {
			dbus_int32_t _tmp21_;
			dbus_message_iter_open_container (&_tmp13_, DBUS_TYPE_VARIANT, "i", &_tmp18_);
			_tmp21_ = g_value_get_int (_value);
			dbus_message_iter_append_basic (&_tmp18_, DBUS_TYPE_INT32, &_tmp21_);
			dbus_message_iter_close_container (&_tmp13_, &_tmp18_);
		} else if (G_VALUE_TYPE (_value) == G_TYPE_UINT) {
			dbus_uint32_t _tmp22_;
			dbus_message_iter_open_container (&_tmp13_, DBUS_TYPE_VARIANT, "u", &_tmp18_);
			_tmp22_ = g_value_get_uint (_value);
			dbus_message_iter_append_basic (&_tmp18_, DBUS_TYPE_UINT32, &_tmp22_);
			dbus_message_iter_close_container (&_tmp13_, &_tmp18_);
		} else if (G_VALUE_TYPE (_value) == G_TYPE_INT64) {
			dbus_int64_t _tmp23_;
			dbus_message_iter_open_container (&_tmp13_, DBUS_TYPE_VARIANT, "x", &_tmp18_);
			_tmp23_ = g_value_get_int64 (_value);
			dbus_message_iter_append_basic (&_tmp18_, DBUS_TYPE_INT64, &_tmp23_);
			dbus_message_iter_close_container (&_tmp13_, &_tmp18_);
		} else if (G_VALUE_TYPE (_value) == G_TYPE_UINT64) {
			dbus_uint64_t _tmp24_;
			dbus_message_iter_open_container (&_tmp13_, DBUS_TYPE_VARIANT, "t", &_tmp18_);
			_tmp24_ = g_value_get_uint64 (_value);
			dbus_message_iter_append_basic (&_tmp18_, DBUS_TYPE_UINT64, &_tmp24_);
			dbus_message_iter_close_container (&_tmp13_, &_tmp18_);
		} else if (G_VALUE_TYPE (_value) == G_TYPE_DOUBLE) {
			double _tmp25_;
			dbus_message_iter_open_container (&_tmp13_, DBUS_TYPE_VARIANT, "d", &_tmp18_);
			_tmp25_ = g_value_get_double (_value);
			dbus_message_iter_append_basic (&_tmp18_, DBUS_TYPE_DOUBLE, &_tmp25_);
			dbus_message_iter_close_container (&_tmp13_, &_tmp18_);
		} else if (G_VALUE_TYPE (_value) == G_TYPE_STRING) {
			const char* _tmp26_;
			dbus_message_iter_open_container (&_tmp13_, DBUS_TYPE_VARIANT, "s", &_tmp18_);
			_tmp26_ = g_value_get_string (_value);
			dbus_message_iter_append_basic (&_tmp18_, DBUS_TYPE_STRING, &_tmp26_);
			dbus_message_iter_close_container (&_tmp13_, &_tmp18_);
		} else if (G_VALUE_TYPE (_value) == G_TYPE_STRV) {
			const char** _tmp27_;
			DBusMessageIter _tmp28_;
			int _tmp29_;
			dbus_message_iter_open_container (&_tmp13_, DBUS_TYPE_VARIANT, "as", &_tmp18_);
			_tmp27_ = g_value_get_boxed (_value);
			dbus_message_iter_open_container (&_tmp18_, DBUS_TYPE_ARRAY, "s", &_tmp28_);
			for (_tmp29_ = 0; _tmp29_ < g_strv_length (g_value_get_boxed (_value)); _tmp29_++) {
				const char* _tmp30_;
				_tmp30_ = *_tmp27_;
				dbus_message_iter_append_basic (&_tmp28_, DBUS_TYPE_STRING, &_tmp30_);
				_tmp27_++;
			}
			dbus_message_iter_close_container (&_tmp18_, &_tmp28_);
			dbus_message_iter_close_container (&_tmp13_, &_tmp18_);
		}
		dbus_message_iter_close_container (&_tmp12_, &_tmp13_);
	}
	dbus_message_iter_close_container (&iter, &_tmp12_);
	_g_hash_table_unref0 (result);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_mpris_player_GetCaps (MprisPlayer* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	gint result;
	DBusMessage* reply;
	dbus_int32_t _tmp31_;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	result = mpris_player_GetCaps (self);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_tmp31_ = result;
	dbus_message_iter_append_basic (&iter, DBUS_TYPE_INT32, &_tmp31_);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_mpris_player_VolumeSet (MprisPlayer* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	gint Volume = 0;
	dbus_int32_t _tmp32_;
	DBusMessage* reply;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "i")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	dbus_message_iter_get_basic (&iter, &_tmp32_);
	dbus_message_iter_next (&iter);
	Volume = _tmp32_;
	mpris_player_VolumeSet (self, Volume);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_mpris_player_VolumeGet (MprisPlayer* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	gint result;
	DBusMessage* reply;
	dbus_int32_t _tmp33_;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	result = mpris_player_VolumeGet (self);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_tmp33_ = result;
	dbus_message_iter_append_basic (&iter, DBUS_TYPE_INT32, &_tmp33_);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_mpris_player_PositionSet (MprisPlayer* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	gint Position = 0;
	dbus_int32_t _tmp34_;
	DBusMessage* reply;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "i")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	dbus_message_iter_get_basic (&iter, &_tmp34_);
	dbus_message_iter_next (&iter);
	Position = _tmp34_;
	mpris_player_PositionSet (self, Position);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_mpris_player_PositionGet (MprisPlayer* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	gint result;
	DBusMessage* reply;
	dbus_int32_t _tmp35_;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	result = mpris_player_PositionGet (self);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_tmp35_ = result;
	dbus_message_iter_append_basic (&iter, DBUS_TYPE_INT32, &_tmp35_);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


DBusHandlerResult mpris_player_dbus_message (DBusConnection* connection, DBusMessage* message, void* object) {
	DBusHandlerResult result;
	result = DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	if (dbus_message_is_method_call (message, "org.freedesktop.DBus.Introspectable", "Introspect")) {
		result = _dbus_mpris_player_introspect (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.DBus.Properties", "GetAll")) {
		result = _dbus_mpris_player_property_get_all (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.MediaPlayer", "Next")) {
		result = _dbus_mpris_player_Next (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.MediaPlayer", "Prev")) {
		result = _dbus_mpris_player_Prev (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.MediaPlayer", "Pause")) {
		result = _dbus_mpris_player_Pause (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.MediaPlayer", "Stop")) {
		result = _dbus_mpris_player_Stop (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.MediaPlayer", "Play")) {
		result = _dbus_mpris_player_Play (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.MediaPlayer", "Repeat")) {
		result = _dbus_mpris_player_Repeat (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.MediaPlayer", "GetStatus")) {
		result = _dbus_mpris_player_GetStatus (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.MediaPlayer", "GetMetadata")) {
		result = _dbus_mpris_player_GetMetadata (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.MediaPlayer", "GetCaps")) {
		result = _dbus_mpris_player_GetCaps (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.MediaPlayer", "VolumeSet")) {
		result = _dbus_mpris_player_VolumeSet (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.MediaPlayer", "VolumeGet")) {
		result = _dbus_mpris_player_VolumeGet (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.MediaPlayer", "PositionSet")) {
		result = _dbus_mpris_player_PositionSet (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.MediaPlayer", "PositionGet")) {
		result = _dbus_mpris_player_PositionGet (object, connection, message);
	}
	if (result == DBUS_HANDLER_RESULT_HANDLED) {
		return result;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static void _dbus_mpris_player_track_change (GObject* _sender, GHashTable* Metadata, DBusConnection* _connection) {
	const char * _path;
	DBusMessage *_message;
	DBusMessageIter _iter;
	DBusMessageIter _tmp36_, _tmp37_;
	GHashTableIter _tmp38_;
	gpointer _tmp39_, _tmp40_;
	_path = g_object_get_data (_sender, "dbus_object_path");
	_message = dbus_message_new_signal (_path, "org.freedesktop.MediaPlayer", "TrackChange");
	dbus_message_iter_init_append (_message, &_iter);
	dbus_message_iter_open_container (&_iter, DBUS_TYPE_ARRAY, "{sv}", &_tmp36_);
	g_hash_table_iter_init (&_tmp38_, Metadata);
	while (g_hash_table_iter_next (&_tmp38_, &_tmp39_, &_tmp40_)) {
		char* _key;
		GValue* _value;
		const char* _tmp41_;
		DBusMessageIter _tmp42_;
		dbus_message_iter_open_container (&_tmp36_, DBUS_TYPE_DICT_ENTRY, NULL, &_tmp37_);
		_key = (char*) _tmp39_;
		_value = (GValue*) _tmp40_;
		_tmp41_ = _key;
		dbus_message_iter_append_basic (&_tmp37_, DBUS_TYPE_STRING, &_tmp41_);
		if (G_VALUE_TYPE (_value) == G_TYPE_UCHAR) {
			guint8 _tmp43_;
			dbus_message_iter_open_container (&_tmp37_, DBUS_TYPE_VARIANT, "y", &_tmp42_);
			_tmp43_ = g_value_get_uchar (_value);
			dbus_message_iter_append_basic (&_tmp42_, DBUS_TYPE_BYTE, &_tmp43_);
			dbus_message_iter_close_container (&_tmp37_, &_tmp42_);
		} else if (G_VALUE_TYPE (_value) == G_TYPE_BOOLEAN) {
			dbus_bool_t _tmp44_;
			dbus_message_iter_open_container (&_tmp37_, DBUS_TYPE_VARIANT, "b", &_tmp42_);
			_tmp44_ = g_value_get_boolean (_value);
			dbus_message_iter_append_basic (&_tmp42_, DBUS_TYPE_BOOLEAN, &_tmp44_);
			dbus_message_iter_close_container (&_tmp37_, &_tmp42_);
		} else if (G_VALUE_TYPE (_value) == G_TYPE_INT) {
			dbus_int32_t _tmp45_;
			dbus_message_iter_open_container (&_tmp37_, DBUS_TYPE_VARIANT, "i", &_tmp42_);
			_tmp45_ = g_value_get_int (_value);
			dbus_message_iter_append_basic (&_tmp42_, DBUS_TYPE_INT32, &_tmp45_);
			dbus_message_iter_close_container (&_tmp37_, &_tmp42_);
		} else if (G_VALUE_TYPE (_value) == G_TYPE_UINT) {
			dbus_uint32_t _tmp46_;
			dbus_message_iter_open_container (&_tmp37_, DBUS_TYPE_VARIANT, "u", &_tmp42_);
			_tmp46_ = g_value_get_uint (_value);
			dbus_message_iter_append_basic (&_tmp42_, DBUS_TYPE_UINT32, &_tmp46_);
			dbus_message_iter_close_container (&_tmp37_, &_tmp42_);
		} else if (G_VALUE_TYPE (_value) == G_TYPE_INT64) {
			dbus_int64_t _tmp47_;
			dbus_message_iter_open_container (&_tmp37_, DBUS_TYPE_VARIANT, "x", &_tmp42_);
			_tmp47_ = g_value_get_int64 (_value);
			dbus_message_iter_append_basic (&_tmp42_, DBUS_TYPE_INT64, &_tmp47_);
			dbus_message_iter_close_container (&_tmp37_, &_tmp42_);
		} else if (G_VALUE_TYPE (_value) == G_TYPE_UINT64) {
			dbus_uint64_t _tmp48_;
			dbus_message_iter_open_container (&_tmp37_, DBUS_TYPE_VARIANT, "t", &_tmp42_);
			_tmp48_ = g_value_get_uint64 (_value);
			dbus_message_iter_append_basic (&_tmp42_, DBUS_TYPE_UINT64, &_tmp48_);
			dbus_message_iter_close_container (&_tmp37_, &_tmp42_);
		} else if (G_VALUE_TYPE (_value) == G_TYPE_DOUBLE) {
			double _tmp49_;
			dbus_message_iter_open_container (&_tmp37_, DBUS_TYPE_VARIANT, "d", &_tmp42_);
			_tmp49_ = g_value_get_double (_value);
			dbus_message_iter_append_basic (&_tmp42_, DBUS_TYPE_DOUBLE, &_tmp49_);
			dbus_message_iter_close_container (&_tmp37_, &_tmp42_);
		} else if (G_VALUE_TYPE (_value) == G_TYPE_STRING) {
			const char* _tmp50_;
			dbus_message_iter_open_container (&_tmp37_, DBUS_TYPE_VARIANT, "s", &_tmp42_);
			_tmp50_ = g_value_get_string (_value);
			dbus_message_iter_append_basic (&_tmp42_, DBUS_TYPE_STRING, &_tmp50_);
			dbus_message_iter_close_container (&_tmp37_, &_tmp42_);
		} else if (G_VALUE_TYPE (_value) == G_TYPE_STRV) {
			const char** _tmp51_;
			DBusMessageIter _tmp52_;
			int _tmp53_;
			dbus_message_iter_open_container (&_tmp37_, DBUS_TYPE_VARIANT, "as", &_tmp42_);
			_tmp51_ = g_value_get_boxed (_value);
			dbus_message_iter_open_container (&_tmp42_, DBUS_TYPE_ARRAY, "s", &_tmp52_);
			for (_tmp53_ = 0; _tmp53_ < g_strv_length (g_value_get_boxed (_value)); _tmp53_++) {
				const char* _tmp54_;
				_tmp54_ = *_tmp51_;
				dbus_message_iter_append_basic (&_tmp52_, DBUS_TYPE_STRING, &_tmp54_);
				_tmp51_++;
			}
			dbus_message_iter_close_container (&_tmp42_, &_tmp52_);
			dbus_message_iter_close_container (&_tmp37_, &_tmp42_);
		}
		dbus_message_iter_close_container (&_tmp36_, &_tmp37_);
	}
	dbus_message_iter_close_container (&_iter, &_tmp36_);
	dbus_connection_send (_connection, _message, NULL);
	dbus_message_unref (_message);
}


static void _dbus_mpris_player_status_change (GObject* _sender, StatusStruct* Status, DBusConnection* _connection) {
	const char * _path;
	DBusMessage *_message;
	DBusMessageIter _iter;
	DBusMessageIter _tmp55_;
	dbus_int32_t _tmp56_;
	dbus_int32_t _tmp57_;
	dbus_int32_t _tmp58_;
	dbus_int32_t _tmp59_;
	_path = g_object_get_data (_sender, "dbus_object_path");
	_message = dbus_message_new_signal (_path, "org.freedesktop.MediaPlayer", "StatusChange");
	dbus_message_iter_init_append (_message, &_iter);
	dbus_message_iter_open_container (&_iter, DBUS_TYPE_STRUCT, NULL, &_tmp55_);
	_tmp56_ = (*Status).playback_state;
	dbus_message_iter_append_basic (&_tmp55_, DBUS_TYPE_INT32, &_tmp56_);
	_tmp57_ = (*Status).shuffle_state;
	dbus_message_iter_append_basic (&_tmp55_, DBUS_TYPE_INT32, &_tmp57_);
	_tmp58_ = (*Status).repeat_current_state;
	dbus_message_iter_append_basic (&_tmp55_, DBUS_TYPE_INT32, &_tmp58_);
	_tmp59_ = (*Status).endless_state;
	dbus_message_iter_append_basic (&_tmp55_, DBUS_TYPE_INT32, &_tmp59_);
	dbus_message_iter_close_container (&_iter, &_tmp55_);
	dbus_connection_send (_connection, _message, NULL);
	dbus_message_unref (_message);
}


static void _dbus_mpris_player_caps_change (GObject* _sender, gint Capabilities, DBusConnection* _connection) {
	const char * _path;
	DBusMessage *_message;
	DBusMessageIter _iter;
	dbus_int32_t _tmp60_;
	_path = g_object_get_data (_sender, "dbus_object_path");
	_message = dbus_message_new_signal (_path, "org.freedesktop.MediaPlayer", "CapsChange");
	dbus_message_iter_init_append (_message, &_iter);
	_tmp60_ = Capabilities;
	dbus_message_iter_append_basic (&_iter, DBUS_TYPE_INT32, &_tmp60_);
	dbus_connection_send (_connection, _message, NULL);
	dbus_message_unref (_message);
}


void mpris_player_dbus_register_object (DBusConnection* connection, const char* path, void* object) {
	if (!g_object_get_data (object, "dbus_object_path")) {
		g_object_set_data (object, "dbus_object_path", g_strdup (path));
		dbus_connection_register_object_path (connection, path, &_mpris_player_dbus_path_vtable, object);
		g_object_weak_ref (object, _vala_dbus_unregister_object, connection);
	}
	g_signal_connect (object, "track-change", (GCallback) _dbus_mpris_player_track_change, connection);
	g_signal_connect (object, "status-change", (GCallback) _dbus_mpris_player_status_change, connection);
	g_signal_connect (object, "caps-change", (GCallback) _dbus_mpris_player_caps_change, connection);
}


static void mpris_player_class_init (MprisPlayerClass * klass) {
	mpris_player_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MprisPlayerPrivate));
	G_OBJECT_CLASS (klass)->finalize = mpris_player_finalize;
	g_signal_new ("track_change", TYPE_MPRIS_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOXED, G_TYPE_NONE, 1, G_TYPE_HASH_TABLE);
	g_signal_new ("status_change", TYPE_MPRIS_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOXED, G_TYPE_NONE, 1, TYPE_STATUS_STRUCT);
	g_signal_new ("caps_change", TYPE_MPRIS_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
	g_type_set_qdata (TYPE_MPRIS_PLAYER, g_quark_from_static_string ("DBusObjectVTable"), (void*) (&_mpris_player_dbus_vtable));
}


static void mpris_player_instance_init (MprisPlayer * self) {
	self->priv = MPRIS_PLAYER_GET_PRIVATE (self);
}


static void mpris_player_finalize (GObject* obj) {
	MprisPlayer * self;
	self = MPRIS_PLAYER (obj);
	G_OBJECT_CLASS (mpris_player_parent_class)->finalize (obj);
}


GType mpris_player_get_type (void) {
	return mpris_player_type_id;
}


GType mpris_player_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (MprisPlayerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mpris_player_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MprisPlayer), 0, (GInstanceInitFunc) mpris_player_instance_init, NULL };
	mpris_player_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "MprisPlayer", &g_define_type_info, 0);
	return mpris_player_type_id;
}


StatusStruct* status_struct_dup (const StatusStruct* self) {
	StatusStruct* dup;
	dup = g_new0 (StatusStruct, 1);
	memcpy (dup, self, sizeof (StatusStruct));
	return dup;
}


void status_struct_free (StatusStruct* self) {
	g_free (self);
}


GType status_struct_get_type (void) {
	static volatile gsize status_struct_type_id__volatile = 0;
	if (g_once_init_enter (&status_struct_type_id__volatile)) {
		GType status_struct_type_id;
		status_struct_type_id = g_boxed_type_register_static ("StatusStruct", (GBoxedCopyFunc) status_struct_dup, (GBoxedFreeFunc) status_struct_free);
		g_once_init_leave (&status_struct_type_id__volatile, status_struct_type_id);
	}
	return status_struct_type_id__volatile;
}


GHashTable* mpris_track_list_GetMetadata (MprisTrackList* self, gint Position) {
	GHashTable* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = NULL;
	return result;
}


gint mpris_track_list_GetCurrentTrack (MprisTrackList* self) {
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	result = 0;
	return result;
}


gint mpris_track_list_GetLength (MprisTrackList* self) {
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	result = 0;
	return result;
}


gint mpris_track_list_AddTrack (MprisTrackList* self, const char* Uri, gboolean PlayImmediately) {
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (Uri != NULL, 0);
	result = 0;
	return result;
}


void mpris_track_list_DelTrack (MprisTrackList* self, gint Position) {
	g_return_if_fail (self != NULL);
}


void mpris_track_list_SetLoop (MprisTrackList* self, gboolean State) {
	g_return_if_fail (self != NULL);
}


void mpris_track_list_SetRandom (MprisTrackList* self, gboolean State) {
	g_return_if_fail (self != NULL);
}


MprisTrackList* mpris_track_list_construct (GType object_type) {
	MprisTrackList * self;
	self = (MprisTrackList*) g_object_new (object_type, NULL);
	return self;
}


MprisTrackList* mpris_track_list_new (void) {
	return mpris_track_list_construct (TYPE_MPRIS_TRACK_LIST);
}


void _mpris_track_list_dbus_unregister (DBusConnection* connection, void* _user_data_) {
}


static DBusHandlerResult _dbus_mpris_track_list_introspect (MprisTrackList* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessage* reply;
	DBusMessageIter iter;
	GString* xml_data;
	char** children;
	int i;
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	xml_data = g_string_new ("<!DOCTYPE node PUBLIC \"-//freedesktop//DTD D-BUS Object Introspection 1.0//EN\" \"http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd\">\n");
	g_string_append (xml_data, "<node>\n<interface name=\"org.freedesktop.DBus.Introspectable\">\n  <method name=\"Introspect\">\n    <arg name=\"data\" direction=\"out\" type=\"s\"/>\n  </method>\n</interface>\n<interface name=\"org.freedesktop.DBus.Properties\">\n  <method name=\"Get\">\n    <arg name=\"interface\" direction=\"in\" type=\"s\"/>\n    <arg name=\"propname\" direction=\"in\" type=\"s\"/>\n    <arg name=\"value\" direction=\"out\" type=\"v\"/>\n  </method>\n  <method name=\"Set\">\n    <arg name=\"interface\" direction=\"in\" type=\"s\"/>\n    <arg name=\"propname\" direction=\"in\" type=\"s\"/>\n    <arg name=\"value\" direction=\"in\" type=\"v\"/>\n  </method>\n  <method name=\"GetAll\">\n    <arg name=\"interface\" direction=\"in\" type=\"s\"/>\n    <arg name=\"props\" direction=\"out\" type=\"a{sv}\"/>\n  </method>\n</interface>\n<interface name=\"org.freedesktop.MediaPlayer\">\n  <method name=\"GetMetadata\">\n    <arg name=\"Position\" type=\"i\" direction=\"in\"/>\n    <arg name=\"result\" type=\"a{sv}\" direction=\"out\"/>\n  </method>\n  <method name=\"GetCurrentTrack\">\n    <arg name=\"result\" type=\"i\" direction=\"out\"/>\n  </method>\n  <method name=\"GetLength\">\n    <arg name=\"result\" type=\"i\" direction=\"out\"/>\n  </method>\n  <method name=\"AddTrack\">\n    <arg name=\"Uri\" type=\"s\" direction=\"in\"/>\n    <arg name=\"PlayImmediately\" type=\"b\" direction=\"in\"/>\n    <arg name=\"result\" type=\"i\" direction=\"out\"/>\n  </method>\n  <method name=\"DelTrack\">\n    <arg name=\"Position\" type=\"i\" direction=\"in\"/>\n  </method>\n  <method name=\"SetLoop\">\n    <arg name=\"State\" type=\"b\" direction=\"in\"/>\n  </method>\n  <method name=\"SetRandom\">\n    <arg name=\"State\" type=\"b\" direction=\"in\"/>\n  </method>\n  <signal name=\"TrackListChange\">\n    <arg name=\"Nb_Tracks\" type=\"i\"/>\n  </signal>\n</interface>\n");
	dbus_connection_list_registered (connection, g_object_get_data ((GObject *) self, "dbus_object_path"), &children);
	for (i = 0; children[i]; i++) {
		g_string_append_printf (xml_data, "<node name=\"%s\"/>\n", children[i]);
	}
	dbus_free_string_array (children);
	g_string_append (xml_data, "</node>\n");
	dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &xml_data->str);
	g_string_free (xml_data, TRUE);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_mpris_track_list_property_get_all (MprisTrackList* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessage* reply;
	DBusMessageIter iter, reply_iter, subiter;
	char* interface_name;
	const char* _tmp61_;
	if (strcmp (dbus_message_get_signature (message), "s")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &reply_iter);
	dbus_message_iter_get_basic (&iter, &_tmp61_);
	dbus_message_iter_next (&iter);
	interface_name = g_strdup (_tmp61_);
	if (strcmp (interface_name, "org.freedesktop.MediaPlayer") == 0) {
		dbus_message_iter_open_container (&reply_iter, DBUS_TYPE_ARRAY, "{sv}", &subiter);
		dbus_message_iter_close_container (&reply_iter, &subiter);
	} else {
		dbus_message_unref (reply);
		reply = NULL;
	}
	g_free (interface_name);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_mpris_track_list_GetMetadata (MprisTrackList* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	gint Position = 0;
	dbus_int32_t _tmp62_;
	GHashTable* result;
	DBusMessage* reply;
	DBusMessageIter _tmp63_, _tmp64_;
	GHashTableIter _tmp65_;
	gpointer _tmp66_, _tmp67_;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "i")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	dbus_message_iter_get_basic (&iter, &_tmp62_);
	dbus_message_iter_next (&iter);
	Position = _tmp62_;
	result = mpris_track_list_GetMetadata (self, Position);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	dbus_message_iter_open_container (&iter, DBUS_TYPE_ARRAY, "{sv}", &_tmp63_);
	g_hash_table_iter_init (&_tmp65_, result);
	while (g_hash_table_iter_next (&_tmp65_, &_tmp66_, &_tmp67_)) {
		char* _key;
		GValue* _value;
		const char* _tmp68_;
		DBusMessageIter _tmp69_;
		dbus_message_iter_open_container (&_tmp63_, DBUS_TYPE_DICT_ENTRY, NULL, &_tmp64_);
		_key = (char*) _tmp66_;
		_value = (GValue*) _tmp67_;
		_tmp68_ = _key;
		dbus_message_iter_append_basic (&_tmp64_, DBUS_TYPE_STRING, &_tmp68_);
		if (G_VALUE_TYPE (_value) == G_TYPE_UCHAR) {
			guint8 _tmp70_;
			dbus_message_iter_open_container (&_tmp64_, DBUS_TYPE_VARIANT, "y", &_tmp69_);
			_tmp70_ = g_value_get_uchar (_value);
			dbus_message_iter_append_basic (&_tmp69_, DBUS_TYPE_BYTE, &_tmp70_);
			dbus_message_iter_close_container (&_tmp64_, &_tmp69_);
		} else if (G_VALUE_TYPE (_value) == G_TYPE_BOOLEAN) {
			dbus_bool_t _tmp71_;
			dbus_message_iter_open_container (&_tmp64_, DBUS_TYPE_VARIANT, "b", &_tmp69_);
			_tmp71_ = g_value_get_boolean (_value);
			dbus_message_iter_append_basic (&_tmp69_, DBUS_TYPE_BOOLEAN, &_tmp71_);
			dbus_message_iter_close_container (&_tmp64_, &_tmp69_);
		} else if (G_VALUE_TYPE (_value) == G_TYPE_INT) {
			dbus_int32_t _tmp72_;
			dbus_message_iter_open_container (&_tmp64_, DBUS_TYPE_VARIANT, "i", &_tmp69_);
			_tmp72_ = g_value_get_int (_value);
			dbus_message_iter_append_basic (&_tmp69_, DBUS_TYPE_INT32, &_tmp72_);
			dbus_message_iter_close_container (&_tmp64_, &_tmp69_);
		} else if (G_VALUE_TYPE (_value) == G_TYPE_UINT) {
			dbus_uint32_t _tmp73_;
			dbus_message_iter_open_container (&_tmp64_, DBUS_TYPE_VARIANT, "u", &_tmp69_);
			_tmp73_ = g_value_get_uint (_value);
			dbus_message_iter_append_basic (&_tmp69_, DBUS_TYPE_UINT32, &_tmp73_);
			dbus_message_iter_close_container (&_tmp64_, &_tmp69_);
		} else if (G_VALUE_TYPE (_value) == G_TYPE_INT64) {
			dbus_int64_t _tmp74_;
			dbus_message_iter_open_container (&_tmp64_, DBUS_TYPE_VARIANT, "x", &_tmp69_);
			_tmp74_ = g_value_get_int64 (_value);
			dbus_message_iter_append_basic (&_tmp69_, DBUS_TYPE_INT64, &_tmp74_);
			dbus_message_iter_close_container (&_tmp64_, &_tmp69_);
		} else if (G_VALUE_TYPE (_value) == G_TYPE_UINT64) {
			dbus_uint64_t _tmp75_;
			dbus_message_iter_open_container (&_tmp64_, DBUS_TYPE_VARIANT, "t", &_tmp69_);
			_tmp75_ = g_value_get_uint64 (_value);
			dbus_message_iter_append_basic (&_tmp69_, DBUS_TYPE_UINT64, &_tmp75_);
			dbus_message_iter_close_container (&_tmp64_, &_tmp69_);
		} else if (G_VALUE_TYPE (_value) == G_TYPE_DOUBLE) {
			double _tmp76_;
			dbus_message_iter_open_container (&_tmp64_, DBUS_TYPE_VARIANT, "d", &_tmp69_);
			_tmp76_ = g_value_get_double (_value);
			dbus_message_iter_append_basic (&_tmp69_, DBUS_TYPE_DOUBLE, &_tmp76_);
			dbus_message_iter_close_container (&_tmp64_, &_tmp69_);
		} else if (G_VALUE_TYPE (_value) == G_TYPE_STRING) {
			const char* _tmp77_;
			dbus_message_iter_open_container (&_tmp64_, DBUS_TYPE_VARIANT, "s", &_tmp69_);
			_tmp77_ = g_value_get_string (_value);
			dbus_message_iter_append_basic (&_tmp69_, DBUS_TYPE_STRING, &_tmp77_);
			dbus_message_iter_close_container (&_tmp64_, &_tmp69_);
		} else if (G_VALUE_TYPE (_value) == G_TYPE_STRV) {
			const char** _tmp78_;
			DBusMessageIter _tmp79_;
			int _tmp80_;
			dbus_message_iter_open_container (&_tmp64_, DBUS_TYPE_VARIANT, "as", &_tmp69_);
			_tmp78_ = g_value_get_boxed (_value);
			dbus_message_iter_open_container (&_tmp69_, DBUS_TYPE_ARRAY, "s", &_tmp79_);
			for (_tmp80_ = 0; _tmp80_ < g_strv_length (g_value_get_boxed (_value)); _tmp80_++) {
				const char* _tmp81_;
				_tmp81_ = *_tmp78_;
				dbus_message_iter_append_basic (&_tmp79_, DBUS_TYPE_STRING, &_tmp81_);
				_tmp78_++;
			}
			dbus_message_iter_close_container (&_tmp69_, &_tmp79_);
			dbus_message_iter_close_container (&_tmp64_, &_tmp69_);
		}
		dbus_message_iter_close_container (&_tmp63_, &_tmp64_);
	}
	dbus_message_iter_close_container (&iter, &_tmp63_);
	_g_hash_table_unref0 (result);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_mpris_track_list_GetCurrentTrack (MprisTrackList* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	gint result;
	DBusMessage* reply;
	dbus_int32_t _tmp82_;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	result = mpris_track_list_GetCurrentTrack (self);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_tmp82_ = result;
	dbus_message_iter_append_basic (&iter, DBUS_TYPE_INT32, &_tmp82_);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_mpris_track_list_GetLength (MprisTrackList* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	gint result;
	DBusMessage* reply;
	dbus_int32_t _tmp83_;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	result = mpris_track_list_GetLength (self);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_tmp83_ = result;
	dbus_message_iter_append_basic (&iter, DBUS_TYPE_INT32, &_tmp83_);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_mpris_track_list_AddTrack (MprisTrackList* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	char* Uri = NULL;
	const char* _tmp84_;
	gboolean PlayImmediately = FALSE;
	dbus_bool_t _tmp85_;
	gint result;
	DBusMessage* reply;
	dbus_int32_t _tmp86_;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "sb")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	dbus_message_iter_get_basic (&iter, &_tmp84_);
	dbus_message_iter_next (&iter);
	Uri = g_strdup (_tmp84_);
	dbus_message_iter_get_basic (&iter, &_tmp85_);
	dbus_message_iter_next (&iter);
	PlayImmediately = _tmp85_;
	result = mpris_track_list_AddTrack (self, Uri, PlayImmediately);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	_g_free0 (Uri);
	_tmp86_ = result;
	dbus_message_iter_append_basic (&iter, DBUS_TYPE_INT32, &_tmp86_);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_mpris_track_list_DelTrack (MprisTrackList* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	gint Position = 0;
	dbus_int32_t _tmp87_;
	DBusMessage* reply;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "i")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	dbus_message_iter_get_basic (&iter, &_tmp87_);
	dbus_message_iter_next (&iter);
	Position = _tmp87_;
	mpris_track_list_DelTrack (self, Position);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_mpris_track_list_SetLoop (MprisTrackList* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	gboolean State = FALSE;
	dbus_bool_t _tmp88_;
	DBusMessage* reply;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "b")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	dbus_message_iter_get_basic (&iter, &_tmp88_);
	dbus_message_iter_next (&iter);
	State = _tmp88_;
	mpris_track_list_SetLoop (self, State);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static DBusHandlerResult _dbus_mpris_track_list_SetRandom (MprisTrackList* self, DBusConnection* connection, DBusMessage* message) {
	DBusMessageIter iter;
	GError* error;
	gboolean State = FALSE;
	dbus_bool_t _tmp89_;
	DBusMessage* reply;
	error = NULL;
	if (strcmp (dbus_message_get_signature (message), "b")) {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
	dbus_message_iter_init (message, &iter);
	dbus_message_iter_get_basic (&iter, &_tmp89_);
	dbus_message_iter_next (&iter);
	State = _tmp89_;
	mpris_track_list_SetRandom (self, State);
	reply = dbus_message_new_method_return (message);
	dbus_message_iter_init_append (reply, &iter);
	if (reply) {
		dbus_connection_send (connection, reply, NULL);
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_HANDLED;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


DBusHandlerResult mpris_track_list_dbus_message (DBusConnection* connection, DBusMessage* message, void* object) {
	DBusHandlerResult result;
	result = DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	if (dbus_message_is_method_call (message, "org.freedesktop.DBus.Introspectable", "Introspect")) {
		result = _dbus_mpris_track_list_introspect (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.DBus.Properties", "GetAll")) {
		result = _dbus_mpris_track_list_property_get_all (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.MediaPlayer", "GetMetadata")) {
		result = _dbus_mpris_track_list_GetMetadata (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.MediaPlayer", "GetCurrentTrack")) {
		result = _dbus_mpris_track_list_GetCurrentTrack (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.MediaPlayer", "GetLength")) {
		result = _dbus_mpris_track_list_GetLength (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.MediaPlayer", "AddTrack")) {
		result = _dbus_mpris_track_list_AddTrack (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.MediaPlayer", "DelTrack")) {
		result = _dbus_mpris_track_list_DelTrack (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.MediaPlayer", "SetLoop")) {
		result = _dbus_mpris_track_list_SetLoop (object, connection, message);
	} else if (dbus_message_is_method_call (message, "org.freedesktop.MediaPlayer", "SetRandom")) {
		result = _dbus_mpris_track_list_SetRandom (object, connection, message);
	}
	if (result == DBUS_HANDLER_RESULT_HANDLED) {
		return result;
	} else {
		return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
	}
}


static void _dbus_mpris_track_list_track_list_change (GObject* _sender, gint Nb_Tracks, DBusConnection* _connection) {
	const char * _path;
	DBusMessage *_message;
	DBusMessageIter _iter;
	dbus_int32_t _tmp90_;
	_path = g_object_get_data (_sender, "dbus_object_path");
	_message = dbus_message_new_signal (_path, "org.freedesktop.MediaPlayer", "TrackListChange");
	dbus_message_iter_init_append (_message, &_iter);
	_tmp90_ = Nb_Tracks;
	dbus_message_iter_append_basic (&_iter, DBUS_TYPE_INT32, &_tmp90_);
	dbus_connection_send (_connection, _message, NULL);
	dbus_message_unref (_message);
}


void mpris_track_list_dbus_register_object (DBusConnection* connection, const char* path, void* object) {
	if (!g_object_get_data (object, "dbus_object_path")) {
		g_object_set_data (object, "dbus_object_path", g_strdup (path));
		dbus_connection_register_object_path (connection, path, &_mpris_track_list_dbus_path_vtable, object);
		g_object_weak_ref (object, _vala_dbus_unregister_object, connection);
	}
	g_signal_connect (object, "track-list-change", (GCallback) _dbus_mpris_track_list_track_list_change, connection);
}


static void mpris_track_list_class_init (MprisTrackListClass * klass) {
	mpris_track_list_parent_class = g_type_class_peek_parent (klass);
	g_signal_new ("track_list_change", TYPE_MPRIS_TRACK_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
	g_type_set_qdata (TYPE_MPRIS_TRACK_LIST, g_quark_from_static_string ("DBusObjectVTable"), (void*) (&_mpris_track_list_dbus_vtable));
}


static void mpris_track_list_instance_init (MprisTrackList * self) {
}


GType mpris_track_list_get_type (void) {
	return mpris_track_list_type_id;
}


GType mpris_track_list_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (MprisTrackListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mpris_track_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MprisTrackList), 0, (GInstanceInitFunc) mpris_track_list_instance_init, NULL };
	mpris_track_list_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "MprisTrackList", &g_define_type_info, 0);
	return mpris_track_list_type_id;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}



static void g_cclosure_user_marshal_VOID__BOXED (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__BOXED) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__BOXED callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__BOXED) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_boxed (param_values + 1), data2);
}



